// ----------------------------------------------------------------------------
// ASTProgramAnnotated.java
// Interface to abstract syntax trees that may have an annotation.
// $Id: ASTProgramAnnotated.java,v 1.2 2009/04/30 12:58:11 schreine Exp $
//
// Author: Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
// Copyright (C) 2009, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.uni-linz.ac.at
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------
package fmrisc.ProgramExplorer.Syntax.Program;

/**
 * 
 * Interface to abstract syntax trees that may have an annotation.
 *
 */
public interface ASTProgramAnnotated extends ASTProgram
{
  /***************************************************************************
   * Set the annotation for this item.
   * @param annotation the annotation.
   **************************************************************************/
  public void setAnnotation(ProgramAnnotation annotation);
  
  /***************************************************************************
   * Get the annotation for this item.
   * @return the annotation (null, if there is none).
   **************************************************************************/
  public ProgramAnnotation getAnnotation();
}

