// ----------------------------------------------------------------------------
// Statement.java
// An interface to program statements
// $Id: Statement.java,v 1.7 2010/11/25 17:23:17 schreine Exp $
//
// Author: Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
// Copyright (C) 2008, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.uni-linz.ac.at
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------
package fmrisc.ProgramExplorer.Syntax.Program;

import fmrisc.ProgramExplorer.Syntax.*;
import fmrisc.ProgramExplorer.Judgements.StatJudgement;

/**
 * An interface to program statements
 */
public interface Statement extends ASTSource, ASTProgramAnnotated
{
  /****************************************************************************
   * Set command judgement.
   * @param spec the judgement.
   ***************************************************************************/
  public void setJudgement(StatJudgement spec);
  
  /****************************************************************************
   * Get command judgement.
   * @return the judgement.
   ***************************************************************************/
  public StatJudgement getJudgement();
  
  /****************************************************************************
   * Get type of statement.
   * @return a string identifying the type of statement.
   ***************************************************************************/
  public String getKind();
}
