// ----------------------------------------------------------------------------
// Util.java
// Some utility functionality.
// $Id: Util.java,v 1.2 2010/06/08 17:00:55 schreine Exp $
//
// Author: Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
// Copyright (C) 2008, Research Institute for Symbolic Computation (RISC)
// Johannes Kepler University, Linz, Austria, http://www.risc.uni-linz.ac.at
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
// ----------------------------------------------------------------------------
package fmrisc.ProgramExplorer;

import fmrisc.External.GeneralHashFunctionLibrary;

/**
 * 
 * Some utility functionality.
 *
 */
public class Util
{
  /***************************************************************************
   * hash string representation of an object to a short word
   * @param rep the string representation of the object
   * @param len the length of the result word
   * @return a hashed version of rep of length len consisting of letters and
   * decimal digits.
   **************************************************************************/
  public static String hash(String rep, int len)
  {
    StringBuffer buffer = new StringBuffer(len);
    long code = hash(rep);
    for (int i=0; i<len; i++)
    {
      long c = code%32;
      if (c < 26)
        buffer.append((char)('a'+c));
      else
        buffer.append((char)('1'+c-26));
      code = code/32;
    }
    return buffer.toString();
  }
  
  /**************************************************************************
   * hash string representation of an object to an integer.
   * @param rep the string representation.
   * @return the hash value.
   *************************************************************************/
  public static long hash(String rep)
  {
    return GeneralHashFunctionLibrary.RSHash(rep);
  }
}
